unit RoutixRPCCOM_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// $Rev: 5081 $
// File generated on 01.08.2011 15:00:14 from Type Library described below.

// ************************************************************************  //
// Type Lib: C:\DEV\RPC\Routix.RPC\RoutixRPCCOM.tlb (1)
// LIBID: {5B063D2F-75E6-45EE-8590-53327672D757}
// LCID: 0
// Helpfile: 
// HelpString: RoutixRPCCOM Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  RoutixRPCCOMMajorVersion = 1;
  RoutixRPCCOMMinorVersion = 0;

  LIBID_RoutixRPCCOM: TGUID = '{5B063D2F-75E6-45EE-8590-53327672D757}';

  IID_IServer: TGUID = '{E401148F-647A-44CE-9957-D93274A0A72B}';
  DIID_IServerEvents: TGUID = '{490F4F36-6B59-4E50-90F4-6D875CEBEA95}';
  CLASS_Server: TGUID = '{E96A0A15-FE3C-48DE-9A78-6E12CE9379EB}';
  IID_IClient: TGUID = '{8B851072-8E84-4970-9999-924D7DE65B26}';
  DIID_IClientEvents: TGUID = '{16217DF0-D2DE-458C-BDFB-CE4581519C92}';
  CLASS_Client: TGUID = '{257DCE84-A606-4950-9C91-74C4912A41F0}';
  IID_IServerEventsHelper: TGUID = '{C6D21433-17C2-448D-8DF8-C4B2B3725C9B}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IServer = interface;
  IServerDisp = dispinterface;
  IServerEvents = dispinterface;
  IClient = interface;
  IClientDisp = dispinterface;
  IClientEvents = dispinterface;
  IServerEventsHelper = interface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  Server = IServer;
  Client = IClient;


// *********************************************************************//
// Interface: IServer
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {E401148F-647A-44CE-9957-D93274A0A72B}
// *********************************************************************//
  IServer = interface(IDispatch)
    ['{E401148F-647A-44CE-9957-D93274A0A72B}']
    procedure StartListen(const AAddressAndPort: WideString); safecall;
    procedure StopListen; safecall;
    function Get_IsListening: WordBool; safecall;
    procedure SetEventsHelper(const AServerEventsHelper: IServerEventsHelper); safecall;
    property IsListening: WordBool read Get_IsListening;
  end;

// *********************************************************************//
// DispIntf:  IServerDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {E401148F-647A-44CE-9957-D93274A0A72B}
// *********************************************************************//
  IServerDisp = dispinterface
    ['{E401148F-647A-44CE-9957-D93274A0A72B}']
    procedure StartListen(const AAddressAndPort: WideString); dispid 201;
    procedure StopListen; dispid 202;
    property IsListening: WordBool readonly dispid 203;
    procedure SetEventsHelper(const AServerEventsHelper: IServerEventsHelper); dispid 204;
  end;

// *********************************************************************//
// DispIntf:  IServerEvents
// Flags:     (4096) Dispatchable
// GUID:      {490F4F36-6B59-4E50-90F4-6D875CEBEA95}
// *********************************************************************//
  IServerEvents = dispinterface
    ['{490F4F36-6B59-4E50-90F4-6D875CEBEA95}']
    procedure OnAuthentication(const AUserName: WideString; const APassword: WideString; 
                               out AIsOk: OleVariant); dispid 201;
    procedure OnRequestObject(const AObjectIDString: WideString; out AResult: OleVariant); dispid 202;
  end;

// *********************************************************************//
// Interface: IClient
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {8B851072-8E84-4970-9999-924D7DE65B26}
// *********************************************************************//
  IClient = interface(IDispatch)
    ['{8B851072-8E84-4970-9999-924D7DE65B26}']
    procedure Connect(const AAddressAndPort: WideString; const AUserName: WideString; 
                      const APassword: WideString); safecall;
    procedure Disconnect; safecall;
    function RequestObject(const AObjectIDString: WideString): OleVariant; safecall;
    function Get_IsConnected: WordBool; safecall;
    property IsConnected: WordBool read Get_IsConnected;
  end;

// *********************************************************************//
// DispIntf:  IClientDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {8B851072-8E84-4970-9999-924D7DE65B26}
// *********************************************************************//
  IClientDisp = dispinterface
    ['{8B851072-8E84-4970-9999-924D7DE65B26}']
    procedure Connect(const AAddressAndPort: WideString; const AUserName: WideString; 
                      const APassword: WideString); dispid 201;
    procedure Disconnect; dispid 202;
    function RequestObject(const AObjectIDString: WideString): OleVariant; dispid 203;
    property IsConnected: WordBool readonly dispid 204;
  end;

// *********************************************************************//
// DispIntf:  IClientEvents
// Flags:     (4096) Dispatchable
// GUID:      {16217DF0-D2DE-458C-BDFB-CE4581519C92}
// *********************************************************************//
  IClientEvents = dispinterface
    ['{16217DF0-D2DE-458C-BDFB-CE4581519C92}']
  end;

// *********************************************************************//
// Interface: IServerEventsHelper
// Flags:     (0)
// GUID:      {C6D21433-17C2-448D-8DF8-C4B2B3725C9B}
// *********************************************************************//
  IServerEventsHelper = interface(IUnknown)
    ['{C6D21433-17C2-448D-8DF8-C4B2B3725C9B}']
    function OnAuthentication(const AUserName: WideString; const APassword: WideString): WordBool; stdcall;
    function OnRequestObject(const AObjectIDString: WideString): OleVariant; stdcall;
  end;

// *********************************************************************//
// The Class CoServer provides a Create and CreateRemote method to          
// create instances of the default interface IServer exposed by              
// the CoClass Server. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoServer = class
    class function Create: IServer;
    class function CreateRemote(const MachineName: string): IServer;
  end;

// *********************************************************************//
// The Class CoClient provides a Create and CreateRemote method to          
// create instances of the default interface IClient exposed by              
// the CoClass Client. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoClient = class
    class function Create: IClient;
    class function CreateRemote(const MachineName: string): IClient;
  end;

implementation

uses ComObj;

class function CoServer.Create: IServer;
begin
  Result := CreateComObject(CLASS_Server) as IServer;
end;

class function CoServer.CreateRemote(const MachineName: string): IServer;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Server) as IServer;
end;

class function CoClient.Create: IClient;
begin
  Result := CreateComObject(CLASS_Client) as IClient;
end;

class function CoClient.CreateRemote(const MachineName: string): IClient;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Client) as IClient;
end;

end.
